Index: drivers/filesystems/btrfs/read.c
===================================================================
--- drivers/filesystems/btrfs/read.c	(révision 74430)
+++ drivers/filesystems/btrfs/read.c	(copie de travail)
@@ -1622,380 +444,180 @@
 #endif
     }
     
-    if (checksum_error) {
-        CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&ci[1];
-#ifdef DEBUG_STATS
-        LARGE_INTEGER time1, time2;
-#endif
+    if (!checksum_error)
+        return STATUS_SUCCESS;
+    
+    if (context->tree) {
+        tree_header* t2;
+        UINT16 j;
+        UINT64 off;
+        UINT16 badsubstripe = 0;
+        BOOL recovered = FALSE;
         
-        // FIXME - update dev stats
+        t2 = ExAllocatePoolWithTag(NonPagedPool, Vcb->superblock.node_size, ALLOC_TAG);
+        if (!t2) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
         
-        WARN("checksum error\n");
+        get_raid0_offset(addr - offset, ci->stripe_length, ci->num_stripes / ci->sub_stripes, &off, &stripe);
         
-        if (!context->tree) {
-            RtlZeroMemory(stripeoff, sizeof(UINT32) * ci->num_stripes / ci->sub_stripes);
-            
-            // find out which stripe the error was on
-            pos = 0;
-            stripe = startoffstripe / ci->sub_stripes;
-            while (pos < length) {
-                if (pos == 0) {
-                    UINT32 readlen = min(stripeend[stripe * ci->sub_stripes] - stripestart[stripe * ci->sub_stripes], ci->stripe_length - (stripestart[stripe * ci->sub_stripes] % ci->stripe_length));
-                    
-                    stripeoff[stripe] += readlen;
-                    pos += readlen;
+        stripe *= ci->sub_stripes;
+        
+        for (j = 0; j < ci->sub_stripes; j++) {
+            if (context->stripes[stripe + j].status == ReadDataStatus_Success) {
+                badsubstripe = j;
+                break;
+            }
+        }
 
-                    for (i = 0; i < readlen / Vcb->superblock.sector_size; i++) {
-                        UINT32 crc32 = ~calc_crc32c(0xffffffff, buf + (i * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
-                    
-                        if (crc32 != context->csum[i])
-                            stripes[stripe]->status = ReadDataStatus_CRCError;
-                    }
-                } else if (length - pos < ci->stripe_length) {
-                    for (i = 0; i < (length - pos) / Vcb->superblock.sector_size; i++) {
-                        UINT32 crc32 = ~calc_crc32c(0xffffffff, buf + pos + (i * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
-                    
-                        if (crc32 != context->csum[(pos / Vcb->superblock.sector_size) + i])
-                            stripes[stripe]->status = ReadDataStatus_CRCError;
-                    }
-                    
-                    pos = length;
+        for (j = 0; j < ci->sub_stripes; j++) {
+            if (context->stripes[stripe + j].status != ReadDataStatus_Success && devices[stripe + j]->devobj) {
+                Status = sync_read_phys(devices[stripe + j]->devobj, cis[stripe + j].offset + off,
+                                        Vcb->superblock.node_size, (UINT8*)t2, FALSE);
+                if (!NT_SUCCESS(Status)) {
+                    WARN("sync_read_phys returned %08x\n", Status);
+                    log_device_error(Vcb, devices[stripe + j], BTRFS_DEV_STAT_READ_ERRORS);
                 } else {
-                    stripeoff[stripe] += ci->stripe_length;
+                    UINT32 crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&t2->fs_uuid, Vcb->superblock.node_size - sizeof(t2->csum));
                     
-                    for (i = 0; i < ci->stripe_length / Vcb->superblock.sector_size; i++) {
-                        UINT32 crc32 = ~calc_crc32c(0xffffffff, buf + pos + (i * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
-                    
-                        if (crc32 != context->csum[(pos / Vcb->superblock.sector_size) + i])
-                            stripes[stripe]->status = ReadDataStatus_CRCError;
-                    }
-                    
-                    pos += ci->stripe_length;
-                }
-                
-                stripe = (stripe + 1) % (ci->num_stripes / ci->sub_stripes);
-            }
-        }
-        
-        context->stripes_left = 0;
-        
-        for (i = 0; i < ci->num_stripes; i++) {
-            if (context->stripes[i].status == ReadDataStatus_CRCError) {
-                UINT16 other_stripe = (i % 1) ? (i - 1) : (i + 1);
-                
-                if (context->stripes[other_stripe].status == ReadDataStatus_Cancelled) {
-                    PIO_STACK_LOCATION IrpSp;
-                    
-                    // re-run Irp that we cancelled
-                    
-                    if (context->stripes[other_stripe].Irp) {
-                        if (devices[other_stripe]->devobj->Flags & DO_DIRECT_IO) {
-                            MmUnlockPages(context->stripes[other_stripe].Irp->MdlAddress);
-                            IoFreeMdl(context->stripes[other_stripe].Irp->MdlAddress);
-                        }
-                        IoFreeIrp(context->stripes[other_stripe].Irp);
-                    }
-                    
-                    if (!Irp) {
-                        context->stripes[other_stripe].Irp = IoAllocateIrp(devices[other_stripe]->devobj->StackSize, FALSE);
+                    if (t2->address == addr && crc32 == *((UINT32*)t2->csum) && (generation == 0 || t2->generation == generation)) {
+                        RtlCopyMemory(buf, t2, Vcb->superblock.node_size);
+                        ERR("recovering from checksum error at %llx, device %llx\n", addr, devices[stripe + j]->devitem.dev_id);
+                        recovered = TRUE;
                         
-                        if (!context->stripes[other_stripe].Irp) {
-                            ERR("IoAllocateIrp failed\n");
-                            return STATUS_INSUFFICIENT_RESOURCES;
+                        if (!Vcb->readonly && !devices[stripe + badsubstripe]->readonly) { // write good data over bad
+                            Status = write_data_phys(devices[stripe + badsubstripe]->devobj, cis[stripe + badsubstripe].offset + off,
+                                                     t2, Vcb->superblock.node_size);
+                            if (!NT_SUCCESS(Status)) {
+                                WARN("write_data_phys returned %08x\n", Status);
+                                log_device_error(Vcb, devices[stripe + badsubstripe], BTRFS_DEV_STAT_WRITE_ERRORS);
+                            }
                         }
-                    } else {
-                        context->stripes[other_stripe].Irp = IoMakeAssociatedIrp(Irp, devices[other_stripe]->devobj->StackSize);
                         
-                        if (!context->stripes[other_stripe].Irp) {
-                            ERR("IoMakeAssociatedIrp failed\n");
-                            return STATUS_INSUFFICIENT_RESOURCES;
-                        }
-                    }
-                    
-                    IrpSp = IoGetNextIrpStackLocation(context->stripes[other_stripe].Irp);
-                    IrpSp->MajorFunction = IRP_MJ_READ;
-                    
-                    if (devices[other_stripe]->devobj->Flags & DO_BUFFERED_IO) {
-                        FIXME("FIXME - buffered IO\n");
-                    } else if (devices[other_stripe]->devobj->Flags & DO_DIRECT_IO) {
-                        context->stripes[other_stripe].Irp->MdlAddress = IoAllocateMdl(context->stripes[other_stripe].buf, stripeend[other_stripe] - stripestart[other_stripe], FALSE, FALSE, NULL);
-                        if (!context->stripes[other_stripe].Irp->MdlAddress) {
-                            ERR("IoAllocateMdl failed\n");
-                            return STATUS_INSUFFICIENT_RESOURCES;
-                        }
-                        
-                        MmProbeAndLockPages(context->stripes[other_stripe].Irp->MdlAddress, KernelMode, IoWriteAccess);
-                    } else {
-                        context->stripes[other_stripe].Irp->UserBuffer = context->stripes[other_stripe].buf;
-                    }
-
-                    IrpSp->Parameters.Read.Length = stripeend[other_stripe] - stripestart[other_stripe];
-                    IrpSp->Parameters.Read.ByteOffset.QuadPart = stripestart[other_stripe] + cis[other_stripe].offset;
-                    
-                    context->stripes[other_stripe].Irp->UserIosb = &context->stripes[other_stripe].iosb;
-                    
-                    IoSetCompletionRoutine(context->stripes[other_stripe].Irp, read_data_completion, &context->stripes[other_stripe], TRUE, TRUE, TRUE);
-                    
-                    context->stripes_left++;
-                    context->stripes[other_stripe].status = ReadDataStatus_Pending;
+                        break;
+                    } else if (t2->address != addr || crc32 != *((UINT32*)t2->csum))
+                        log_device_error(Vcb, devices[stripe + j], BTRFS_DEV_STAT_CORRUPTION_ERRORS);
+                    else
+                        log_device_error(Vcb, devices[stripe + j], BTRFS_DEV_STAT_GENERATION_ERRORS);
                 }
             }
         }
         
-        if (context->stripes_left == 0) {
-            WARN("could not recover from checksum error\n");
-            ExFreePool(stripes);
-            ExFreePool(stripeoff);
+        if (!recovered) {
+            ERR("unrecoverable checksum error at %llx\n", addr);
+            ExFreePool(t2);
             return STATUS_CRC_ERROR;
         }
+
+        ExFreePool(t2);
+    } else {
+        ULONG sectors = length / Vcb->superblock.sector_size;
+        UINT8* sector;
         
-        context->stripes_cancel = 0;
-        KeClearEvent(&context->Event);
-        
-#ifdef DEBUG_STATS
-        if (!context->tree)
-            time1 = KeQueryPerformanceCounter(NULL);
-#endif
-
-        for (i = 0; i < ci->num_stripes; i++) {
-            if (context->stripes[i].status == ReadDataStatus_Pending) {
-                IoCallDriver(devices[i]->devobj, context->stripes[i].Irp);
-            }
+        sector = ExAllocatePoolWithTag(NonPagedPool, Vcb->superblock.sector_size, ALLOC_TAG);
+        if (!sector) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
         }
         
-        KeWaitForSingleObject(&context->Event, Executive, KernelMode, FALSE, NULL);
-        
-#ifdef DEBUG_STATS
-        if (!context->tree) {
-            time2 = KeQueryPerformanceCounter(NULL);
+        for (i = 0; i < sectors; i++) {
+            UINT32 crc32 = ~calc_crc32c(0xffffffff, buf + (i * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
             
-            Vcb->stats.read_disk_time += time2.QuadPart - time1.QuadPart;
-        }
-#endif
-
-        for (i = 0; i < ci->num_stripes; i++) {
-            if (context->stripes[i].status == ReadDataStatus_CRCError) {
-                UINT16 other_stripe = (i % 1) ? (i - 1) : (i + 1);
+            if (context->csum[i] != crc32) {
+                UINT16 j;
+                UINT64 off;
+                UINT16 stripe, badsubstripe = 0;
+                BOOL recovered = FALSE;
                 
-                if (context->stripes[other_stripe].status != ReadDataStatus_Success) {
-                    WARN("could not recover from checksum error\n");
-                    ExFreePool(stripes);
-                    ExFreePool(stripeoff);
-                    return STATUS_CRC_ERROR;
-                }
-            }
-        }
-
-        RtlZeroMemory(stripeoff, sizeof(UINT32) * ci->num_stripes / ci->sub_stripes);
-    
-        pos = 0;
-        stripe = startoffstripe / ci->sub_stripes;
-        while (pos < length) {
-            if (pos == 0) {
-                UINT32 readlen = min(stripeend[stripe * ci->sub_stripes] - stripestart[stripe * ci->sub_stripes], ci->stripe_length - (stripestart[stripe * ci->sub_stripes] % ci->stripe_length));
+                get_raid0_offset(addr - offset + UInt32x32To64(i, Vcb->superblock.sector_size), ci->stripe_length,
+                                 ci->num_stripes / ci->sub_stripes, &off, &stripe);
                 
-                stripeoff[stripe] += readlen;
-                pos += readlen;
+                stripe *= ci->sub_stripes;
                 
-                if (context->csum && stripes[stripe]->status == ReadDataStatus_CRCError) {
-                    for (i = 0; i < readlen / Vcb->superblock.sector_size; i++) {
-                        UINT32 crc32 = ~calc_crc32c(0xffffffff, buf + (i * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
-                    
-                        if (crc32 != context->csum[i]) {
-                            UINT16 other_stripe = (stripe * ci->sub_stripes) + (context->stripes[stripe * ci->sub_stripes].status == ReadDataStatus_CRCError ? 1 : 0);
-                            UINT32 crc32b = ~calc_crc32c(0xffffffff, context->stripes[other_stripe].buf + (i * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
-                            
-                            if (crc32b == context->csum[i]) {
-                                RtlCopyMemory(buf + (i * Vcb->superblock.sector_size), context->stripes[other_stripe].buf + (i * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
-                                RtlCopyMemory(stripes[stripe]->buf + (i * Vcb->superblock.sector_size), context->stripes[other_stripe].buf + (i * Vcb->superblock.sector_size),
-                                                Vcb->superblock.sector_size);
-                                stripes[stripe]->rewrite = TRUE;
-                            } else {
-                                WARN("could not recover from checksum error\n");
-                                ExFreePool(stripes);
-                                ExFreePool(stripeoff);
-                                return STATUS_CRC_ERROR;
-                            }
-                        }
+                for (j = 0; j < ci->sub_stripes; j++) {
+                    if (context->stripes[stripe + j].status == ReadDataStatus_Success) {
+                        badsubstripe = j;
+                        break;
                     }
-                } else if (context->tree) {
-                    UINT16 other_stripe = (stripe * ci->sub_stripes) + (context->stripes[stripe * ci->sub_stripes].status == ReadDataStatus_CRCError ? 1 : 0);
-                    tree_header* th = (tree_header*)buf;
-                    UINT32 crc32;
-                    
-                    RtlCopyMemory(buf, context->stripes[other_stripe].buf, readlen);
-                    
-                    crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&th->fs_uuid, Vcb->superblock.node_size - sizeof(th->csum));
-                    
-                    if (addr != th->address || crc32 != *((UINT32*)th->csum)) {
-                        WARN("could not recover from checksum error\n");
-                        ExFreePool(stripes);
-                        ExFreePool(stripeoff);
-                        return STATUS_CRC_ERROR;
-                    }
-                    
-                    RtlCopyMemory(stripes[stripe]->buf, buf, readlen);
-                    stripes[stripe]->rewrite = TRUE;
                 }
-            } else if (length - pos < ci->stripe_length) {
-                if (context->csum && stripes[stripe]->status == ReadDataStatus_CRCError) {
-                    for (i = 0; i < (length - pos) / Vcb->superblock.sector_size; i++) {
-                        UINT32 crc32 = ~calc_crc32c(0xffffffff, buf + pos + (i * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
-                    
-                        if (crc32 != context->csum[(pos / Vcb->superblock.sector_size) + i]) {
-                            UINT16 other_stripe = (stripe * ci->sub_stripes) + (context->stripes[stripe * ci->sub_stripes].status == ReadDataStatus_CRCError ? 1 : 0);
-                            UINT32 crc32b = ~calc_crc32c(0xffffffff, &context->stripes[other_stripe].buf[stripeoff[stripe] + (i * Vcb->superblock.sector_size)],
-                                                            Vcb->superblock.sector_size);
+                
+                log_device_error(Vcb, devices[stripe + badsubstripe], BTRFS_DEV_STAT_CORRUPTION_ERRORS);
+                
+                for (j = 0; j < ci->sub_stripes; j++) {
+                    if (context->stripes[stripe + j].status != ReadDataStatus_Success && devices[stripe + j]->devobj) {
+                        Status = sync_read_phys(devices[stripe + j]->devobj, cis[stripe + j].offset + off,
+                                                Vcb->superblock.sector_size, sector, FALSE);
+                        if (!NT_SUCCESS(Status)) {
+                            WARN("sync_read_phys returned %08x\n", Status);
+                            log_device_error(Vcb, devices[stripe + j], BTRFS_DEV_STAT_READ_ERRORS);
+                        } else {
+                            UINT32 crc32b = ~calc_crc32c(0xffffffff, sector, Vcb->superblock.sector_size);
                             
                             if (crc32b == context->csum[i]) {
-                                RtlCopyMemory(buf + pos + (i * Vcb->superblock.sector_size),
-                                                &context->stripes[other_stripe].buf[stripeoff[stripe] + (i * Vcb->superblock.sector_size)], Vcb->superblock.sector_size);
-                                RtlCopyMemory(&stripes[stripe]->buf[stripeoff[stripe] + (i * Vcb->superblock.sector_size)],
-                                                &context->stripes[other_stripe].buf[stripeoff[stripe] + (i * Vcb->superblock.sector_size)],
-                                                Vcb->superblock.sector_size);
-                                stripes[stripe]->rewrite = TRUE;
-                            } else {
-                                WARN("could not recover from checksum error\n");
-                                ExFreePool(stripes);
-                                ExFreePool(stripeoff);
-                                return STATUS_CRC_ERROR;
-                            }
+                                RtlCopyMemory(buf + (i * Vcb->superblock.sector_size), sector, Vcb->superblock.sector_size);
+                                ERR("recovering from checksum error at %llx, device %llx\n", addr + UInt32x32To64(i, Vcb->superblock.sector_size), devices[stripe + j]->devitem.dev_id);
+                                recovered = TRUE;
+                                
+                                if (!Vcb->readonly && !devices[stripe + badsubstripe]->readonly) { // write good data over bad
+                                    Status = write_data_phys(devices[stripe + badsubstripe]->devobj, cis[stripe + badsubstripe].offset + off,
+                                                             sector, Vcb->superblock.sector_size);
+                                    if (!NT_SUCCESS(Status)) {
+                                        WARN("write_data_phys returned %08x\n", Status);
+                                        log_device_error(Vcb, devices[stripe + badsubstripe], BTRFS_DEV_STAT_READ_ERRORS);
+                                    }
+                                }
+                                
+                                break;
+                            } else
+                                log_device_error(Vcb, devices[stripe + j], BTRFS_DEV_STAT_CORRUPTION_ERRORS);
                         }
                     }
                 }
                 
-                pos = length;
-            } else {
-                if (context->csum && stripes[stripe]->status == ReadDataStatus_CRCError) {
-                    for (i = 0; i < ci->stripe_length / Vcb->superblock.sector_size; i++) {
-                        UINT32 crc32 = ~calc_crc32c(0xffffffff, buf + pos + (i * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
-                    
-                        if (crc32 != context->csum[(pos / Vcb->superblock.sector_size) + i]) {
-                            UINT16 other_stripe = (stripe * ci->sub_stripes) + (context->stripes[stripe * ci->sub_stripes].status == ReadDataStatus_CRCError ? 1 : 0);
-                            UINT32 crc32b = ~calc_crc32c(0xffffffff, &context->stripes[other_stripe].buf[stripeoff[stripe] + (i * Vcb->superblock.sector_size)],
-                                                            Vcb->superblock.sector_size);
-                            
-                            if (crc32b == context->csum[i]) {
-                                RtlCopyMemory(buf + pos + (i * Vcb->superblock.sector_size),
-                                                &context->stripes[other_stripe].buf[stripeoff[stripe] + (i * Vcb->superblock.sector_size)], Vcb->superblock.sector_size);
-                                RtlCopyMemory(&stripes[stripe]->buf[stripeoff[stripe] + (i * Vcb->superblock.sector_size)],
-                                                &context->stripes[other_stripe].buf[stripeoff[stripe] + (i * Vcb->superblock.sector_size)],
-                                                Vcb->superblock.sector_size);
-                                stripes[stripe]->rewrite = TRUE;
-                            } else {
-                                WARN("could not recover from checksum error\n");
-                                ExFreePool(stripes);
-                                ExFreePool(stripeoff);
-                                return STATUS_CRC_ERROR;
-                            }
-                        }
-                    }
+                if (!recovered) {
+                    ERR("unrecoverable checksum error at %llx\n", addr + UInt32x32To64(i, Vcb->superblock.sector_size));
+                    ExFreePool(sector);
+                    return STATUS_CRC_ERROR;
                 }
-                
-                stripeoff[stripe] += ci->stripe_length;
-                pos += ci->stripe_length;
             }
-            
-            stripe = (stripe + 1) % (ci->num_stripes / ci->sub_stripes);
         }
         
-        // write good data over bad
-        
-        if (!Vcb->readonly) {
-            for (i = 0; i < ci->num_stripes; i++) {
-                if (context->stripes[i].rewrite && devices[i] && !devices[i]->readonly) {
-                    Status = write_data_phys(devices[i]->devobj, cis[i].offset + stripestart[i], context->stripes[i].buf, stripeend[i] - stripestart[i]);
-                    
-                    if (!NT_SUCCESS(Status))
-                        WARN("write_data_phys returned %08x\n", Status);
-                }
-            }
-        }
+        ExFreePool(sector);
     }
     
-    ExFreePool(stripes);
-    ExFreePool(stripeoff);
-    
-    // FIXME - handle the case where one of the stripes doesn't read everything, i.e. Irp->IoStatus.Information is short
-    
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS read_data_raid5(device_extension* Vcb, UINT8* buf, UINT64 addr, UINT32 length, PIRP Irp, read_data_context* context, CHUNK_ITEM* ci,
-                                device** devices, UINT64* stripestart, UINT64* stripeend, UINT64 offset, UINT32 firststripesize, BOOL check_nocsum_parity) {
-    UINT32 pos, skip;
+static NTSTATUS read_data_raid5(device_extension* Vcb, UINT8* buf, UINT64 addr, UINT32 length, read_data_context* context, CHUNK_ITEM* ci,
+                                device** devices, UINT64 offset, UINT64 generation, chunk* c) {
+    ULONG i;
     NTSTATUS Status;
-    int num_errors = 0;
-    UINT64 i, off, stripeoff, origoff;
-    BOOL needs_reconstruct = FALSE;
-    UINT64 reconstruct_stripe;
     BOOL checksum_error = FALSE;
+    CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&ci[1];
+    UINT64 lockaddr, locklen;
+    UINT16 stripe;
     
     for (i = 0; i < ci->num_stripes; i++) {
         if (context->stripes[i].status == ReadDataStatus_Error) {
-            num_errors++;
-            if (num_errors > 1)
-                break;
-        }
+            WARN("stripe %llu returned error %08x\n", i, context->stripes[i].iosb.Status);
+            log_device_error(Vcb, devices[i], BTRFS_DEV_STAT_READ_ERRORS);
+            return context->stripes[i].iosb.Status;
+        } else if (context->stripes[i].status == ReadDataStatus_Success)
+            stripe = i;
     }
     
-    if (num_errors > 1) {
-        for (i = 0; i < ci->num_stripes; i++) {
-            if (context->stripes[i].status == ReadDataStatus_Error) {
-                WARN("stripe %llu returned error %08x\n", i, context->stripes[i].iosb.Status); 
-                return context->stripes[i].iosb.Status;
-            }
-        }
-    }
-    
-    off = addr - offset;
-    off -= off % ((ci->num_stripes - 1) * ci->stripe_length);
-    skip = addr - offset - off;
-    origoff = off;
-    
-    for (i = 0; i < ci->num_stripes; i++) {
-        if (context->stripes[i].status == ReadDataStatus_Cancelled) {
-            if (needs_reconstruct) {
-                ERR("more than one stripe needs reconstruction\n");
-                return STATUS_INTERNAL_ERROR;
-            } else {
-                needs_reconstruct = TRUE;
-                reconstruct_stripe = i;
-            }
-        }
-    }
-    
-    if (needs_reconstruct) {
-        TRACE("reconstructing stripe %u\n", reconstruct_stripe);
-        
-        stripeoff = 0;
-        
-        raid5_reconstruct(off, skip, context, ci, &stripeoff, stripeend[reconstruct_stripe] - stripestart[reconstruct_stripe], TRUE, firststripesize, reconstruct_stripe);
-        
-        while (stripeoff < stripeend[0] - stripestart[0]) {
-            off += (ci->num_stripes - 1) * ci->stripe_length;
-            raid5_reconstruct(off, 0, context, ci, &stripeoff, stripeend[reconstruct_stripe] - stripestart[reconstruct_stripe], FALSE, 0, reconstruct_stripe);
-        }
-        
-        off = addr - offset;
-        off -= off % ((ci->num_stripes - 1) * ci->stripe_length);
-    }
-    
-    pos = 0;
-    stripeoff = 0;
-    raid5_decode(off, skip, context, ci, &stripeoff, buf, &pos, length, firststripesize);
-    
-    while (pos < length) {
-        off += (ci->num_stripes - 1) * ci->stripe_length;
-        raid5_decode(off, 0, context, ci, &stripeoff, buf, &pos, length, 0);
-    }
-    
     if (context->tree) {
         tree_header* th = (tree_header*)buf;
         UINT32 crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&th->fs_uuid, Vcb->superblock.node_size - sizeof(th->csum));
         
-        if (addr != th->address || crc32 != *((UINT32*)th->csum))
+        if (addr != th->address || crc32 != *((UINT32*)th->csum)) {
             checksum_error = TRUE;
+            log_device_error(Vcb, devices[stripe], BTRFS_DEV_STAT_CORRUPTION_ERRORS);
+        } else if (generation != 0 && generation != th->generation) {
+            checksum_error = TRUE;
+            log_device_error(Vcb, devices[stripe], BTRFS_DEV_STAT_GENERATION_ERRORS);
+        }
     } else if (context->csum) {
 #ifdef DEBUG_STATS
         LARGE_INTEGER time1, time2;
